<?xml version='1.0' encoding='utf-8'?>
<FilingSummary>
  <Version>3.10.0.1</Version>
  <ProcessingTime/>
  <ReportFormat>html</ReportFormat>
  <ContextCount>320</ContextCount>
  <ElementCount>525</ElementCount>
  <EntityCount>1</EntityCount>
  <FootnotesReported>true</FootnotesReported>
  <SegmentCount>144</SegmentCount>
  <ScenarioCount>0</ScenarioCount>
  <TuplesReported>false</TuplesReported>
  <UnitCount>9</UnitCount>
  <MyReports>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R1.htm</HtmlFileName>
      <LongName>0001000 - Document - Document and Entity Information</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/DocumentAndEntityInformation</Role>
      <ShortName>Document and Entity Information</ShortName>
      <MenuCategory>Cover</MenuCategory>
      <Position>1</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R2.htm</HtmlFileName>
      <LongName>1001000 - Statement - Consolidated Balance Sheets</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/ConsolidatedBalanceSheets</Role>
      <ShortName>Consolidated Balance Sheets</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>2</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R3.htm</HtmlFileName>
      <LongName>1001501 - Statement - Consolidated Balance Sheets (Parenthetical)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/ConsolidatedBalanceSheetsParenthetical</Role>
      <ShortName>Consolidated Balance Sheets (Parenthetical)</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>3</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R4.htm</HtmlFileName>
      <LongName>1002000 - Statement - Consolidated Statements of Operations and Comprehensive Income</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/ConsolidatedStatementsOfOperationsAndComprehensiveIncome</Role>
      <ShortName>Consolidated Statements of Operations and Comprehensive Income</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>4</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R5.htm</HtmlFileName>
      <LongName>1003000 - Statement - Consolidated Statements of Changes in Shareholders' Equity</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/ConsolidatedStatementsOfChangesInShareholdersEquity</Role>
      <ShortName>Consolidated Statements of Changes in Shareholders' Equity</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>5</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R6.htm</HtmlFileName>
      <LongName>1003001 - Statement - Consolidated Statements of Changes in Stockholders' Equity (Parenthetical)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/ConsolidatedStatementsOfChangesInStockholdersEquityParenthetical</Role>
      <ShortName>Consolidated Statements of Changes in Stockholders' Equity (Parenthetical)</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>6</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R7.htm</HtmlFileName>
      <LongName>1004000 - Statement - Consolidated Statements of Cash Flows</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/ConsolidatedStatementsOfCashFlows</Role>
      <ShortName>Consolidated Statements of Cash Flows</ShortName>
      <MenuCategory>Statements</MenuCategory>
      <Position>7</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R8.htm</HtmlFileName>
      <LongName>2101100 - Disclosure - Nature of operations</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/NatureOfOperations</Role>
      <ShortName>Nature of operations</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>8</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R9.htm</HtmlFileName>
      <LongName>2102100 - Disclosure - Significant accounting policies</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SignificantAccountingPolicies</Role>
      <ShortName>Significant accounting policies</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>9</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R10.htm</HtmlFileName>
      <LongName>2103100 - Disclosure - Accounting pronouncements recently adopted</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AccountingPronouncementsRecentlyAdopted</Role>
      <ShortName>Accounting pronouncements recently adopted</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>10</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R11.htm</HtmlFileName>
      <LongName>2104100 - Disclosure - Recent accounting pronouncements not yet adopted</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RecentAccountingPronouncementsNotYetAdopted</Role>
      <ShortName>Recent accounting pronouncements not yet adopted</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>11</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R12.htm</HtmlFileName>
      <LongName>2105100 - Disclosure - Acquisitions</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/Acquisitions</Role>
      <ShortName>Acquisitions</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>12</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R13.htm</HtmlFileName>
      <LongName>2108100 - Disclosure - Accounts receivable</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AccountsReceivable</Role>
      <ShortName>Accounts receivable</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>13</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R14.htm</HtmlFileName>
      <LongName>2111100 - Disclosure - Prepaid expenses and deposits</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/PrepaidExpensesAndDeposits</Role>
      <ShortName>Prepaid expenses and deposits</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>14</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R15.htm</HtmlFileName>
      <LongName>2112100 - Disclosure - Assets held for sale</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AssetsHeldForSale</Role>
      <ShortName>Assets held for sale</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>15</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R16.htm</HtmlFileName>
      <LongName>2113100 - Disclosure - Property, plant and equipment</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/PropertyPlantAndEquipment</Role>
      <ShortName>Property, plant and equipment</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>16</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R17.htm</HtmlFileName>
      <LongName>2115100 - Disclosure - Other assets</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherAssets</Role>
      <ShortName>Other assets</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>17</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R18.htm</HtmlFileName>
      <LongName>2116100 - Disclosure - Income taxes</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/IncomeTaxes</Role>
      <ShortName>Income taxes</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>18</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R19.htm</HtmlFileName>
      <LongName>2117100 - Disclosure - Accrued liabilities</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AccruedLiabilities</Role>
      <ShortName>Accrued liabilities</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>19</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R20.htm</HtmlFileName>
      <LongName>2118100 - Disclosure - Investments in affiliates and joint ventures</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InvestmentsInAffiliatesAndJointVentures</Role>
      <ShortName>Investments in affiliates and joint ventures</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>20</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R21.htm</HtmlFileName>
      <LongName>2119100 - Disclosure - Long term debt</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebt</Role>
      <ShortName>Long term debt</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>21</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R22.htm</HtmlFileName>
      <LongName>2120100 - Disclosure - Capital lease obligations</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/CapitalLeaseObligations</Role>
      <ShortName>Capital lease obligations</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>22</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R23.htm</HtmlFileName>
      <LongName>2121100 - Disclosure - Financial instruments and risk management</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/FinancialInstrumentsAndRiskManagement</Role>
      <ShortName>Financial instruments and risk management</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>23</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R24.htm</HtmlFileName>
      <LongName>2122100 - Disclosure - Other long term obligations</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherLongTermObligations</Role>
      <ShortName>Other long term obligations</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>24</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R25.htm</HtmlFileName>
      <LongName>2124100 - Disclosure - Shares</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/Shares</Role>
      <ShortName>Shares</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>25</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R26.htm</HtmlFileName>
      <LongName>2126100 - Disclosure - Revenue</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/Revenue</Role>
      <ShortName>Revenue</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>26</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R27.htm</HtmlFileName>
      <LongName>2127100 - Disclosure - Commitments</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/Commitments</Role>
      <ShortName>Commitments</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>27</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R28.htm</HtmlFileName>
      <LongName>2128100 - Disclosure - Interest expense</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InterestExpense</Role>
      <ShortName>Interest expense</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>28</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R29.htm</HtmlFileName>
      <LongName>2130100 - Disclosure - Stock-based compensation</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/StockBasedCompensation</Role>
      <ShortName>Stock-based compensation</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>29</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R30.htm</HtmlFileName>
      <LongName>2131100 - Disclosure - Other information</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherInformation</Role>
      <ShortName>Other information</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>30</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R31.htm</HtmlFileName>
      <LongName>2134100 - Disclosure - Employee benefit plans</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/EmployeeBenefitPlans</Role>
      <ShortName>Employee benefit plans</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>31</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R32.htm</HtmlFileName>
      <LongName>2135100 - Disclosure - Related party transactions</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RelatedPartyTransactions</Role>
      <ShortName>Related party transactions</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>32</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R33.htm</HtmlFileName>
      <LongName>2136100 - Disclosure - Comparative figures</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/ComparativeFigures</Role>
      <ShortName>Comparative figures</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>33</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R34.htm</HtmlFileName>
      <LongName>2137100 - Disclosure - Contingencies</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/Contingencies</Role>
      <ShortName>Contingencies</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>34</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R35.htm</HtmlFileName>
      <LongName>2202201 - Disclosure - Significant accounting policies (Policies)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SignificantAccountingPoliciesPolicies</Role>
      <ShortName>Significant accounting policies (Policies)</ShortName>
      <MenuCategory>Policies</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/AccountingPronouncementsRecentlyAdopted</ParentRole>
      <Position>35</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R36.htm</HtmlFileName>
      <LongName>2302302 - Disclosure - Significant accounting policies (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SignificantAccountingPoliciesTables</Role>
      <ShortName>Significant accounting policies (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/SignificantAccountingPolicies</ParentRole>
      <Position>36</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R37.htm</HtmlFileName>
      <LongName>2303301 - Disclosure - Accounting pronouncements recently adopted (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AccountingPronouncementsRecentlyAdoptedTables</Role>
      <ShortName>Accounting pronouncements recently adopted (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/AccountingPronouncementsRecentlyAdopted</ParentRole>
      <Position>37</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R38.htm</HtmlFileName>
      <LongName>2305301 - Disclosure - Acquisitions (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AcquisitionsTables</Role>
      <ShortName>Acquisitions (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/Acquisitions</ParentRole>
      <Position>38</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R39.htm</HtmlFileName>
      <LongName>2308301 - Disclosure - Accounts receivable (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AccountsReceivableTables</Role>
      <ShortName>Accounts receivable (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/AccountsReceivable</ParentRole>
      <Position>39</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R40.htm</HtmlFileName>
      <LongName>2311301 - Disclosure - Prepaid expenses and deposits (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/PrepaidExpensesAndDepositsTables</Role>
      <ShortName>Prepaid expenses and deposits (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/PrepaidExpensesAndDeposits</ParentRole>
      <Position>40</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R41.htm</HtmlFileName>
      <LongName>2313301 - Disclosure - Property, plant and equipment (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/PropertyPlantAndEquipmentTables</Role>
      <ShortName>Property, plant and equipment (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/PropertyPlantAndEquipment</ParentRole>
      <Position>41</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R42.htm</HtmlFileName>
      <LongName>2315301 - Disclosure - Other assets (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherAssetsTables</Role>
      <ShortName>Other assets (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/OtherAssets</ParentRole>
      <Position>42</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R43.htm</HtmlFileName>
      <LongName>2316301 - Disclosure - Income taxes (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/IncomeTaxesTables</Role>
      <ShortName>Income taxes (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/IncomeTaxes</ParentRole>
      <Position>43</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R44.htm</HtmlFileName>
      <LongName>2317301 - Disclosure - Accrued liabilities (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AccruedLiabilitiesTables</Role>
      <ShortName>Accrued liabilities (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/AccruedLiabilities</ParentRole>
      <Position>44</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R45.htm</HtmlFileName>
      <LongName>2318301 - Disclosure - Investments in affiliates and joint ventures (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InvestmentsInAffiliatesAndJointVenturesTables</Role>
      <ShortName>Investments in affiliates and joint ventures (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/InvestmentsInAffiliatesAndJointVentures</ParentRole>
      <Position>45</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R46.htm</HtmlFileName>
      <LongName>2319301 - Disclosure - Long term debt (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebtTables</Role>
      <ShortName>Long term debt (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/LongTermDebt</ParentRole>
      <Position>46</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R47.htm</HtmlFileName>
      <LongName>2320301 - Disclosure - Capital lease obligations (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/CapitalLeaseObligationsTables</Role>
      <ShortName>Capital lease obligations (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/CapitalLeaseObligations</ParentRole>
      <Position>47</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R48.htm</HtmlFileName>
      <LongName>2321301 - Disclosure - Financial instruments and risk management (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/FinancialInstrumentsAndRiskManagementTables</Role>
      <ShortName>Financial instruments and risk management (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/FinancialInstrumentsAndRiskManagement</ParentRole>
      <Position>48</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R49.htm</HtmlFileName>
      <LongName>2322301 - Disclosure - Other long term obligations (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherLongTermObligationsTables</Role>
      <ShortName>Other long term obligations (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/OtherLongTermObligations</ParentRole>
      <Position>49</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R50.htm</HtmlFileName>
      <LongName>2324301 - Disclosure - Shares (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SharesTables</Role>
      <ShortName>Shares (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/Shares</ParentRole>
      <Position>50</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R51.htm</HtmlFileName>
      <LongName>2326301 - Disclosure - Revenue (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RevenueTables</Role>
      <ShortName>Revenue (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/Revenue</ParentRole>
      <Position>51</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R52.htm</HtmlFileName>
      <LongName>2327301 - Disclosure - Commitments (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/CommitmentsTables</Role>
      <ShortName>Commitments (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/Commitments</ParentRole>
      <Position>52</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R53.htm</HtmlFileName>
      <LongName>2328301 - Disclosure - Interest expense (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InterestExpenseTables</Role>
      <ShortName>Interest expense (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/InterestExpense</ParentRole>
      <Position>53</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R54.htm</HtmlFileName>
      <LongName>2330301 - Disclosure - Stock-based compensation (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/StockBasedCompensationTables</Role>
      <ShortName>Stock-based compensation (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/StockBasedCompensation</ParentRole>
      <Position>54</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R55.htm</HtmlFileName>
      <LongName>2331301 - Disclosure - Other information (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherInformationTables</Role>
      <ShortName>Other information (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/OtherInformation</ParentRole>
      <Position>55</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R56.htm</HtmlFileName>
      <LongName>2335301 - Disclosure - Related party transactions (Tables)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RelatedPartyTransactionsTables</Role>
      <ShortName>Related party transactions (Tables)</ShortName>
      <MenuCategory>Tables</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/RelatedPartyTransactions</ParentRole>
      <Position>56</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R57.htm</HtmlFileName>
      <LongName>2402403 - Disclosure - Significant accounting policies - Property, plant and equipment (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SignificantAccountingPoliciesPropertyPlantAndEquipmentDetails</Role>
      <ShortName>Significant accounting policies - Property, plant and equipment (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>57</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R58.htm</HtmlFileName>
      <LongName>2402404 - Disclosure - Significant accounting policies - Intangible assets (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SignificantAccountingPoliciesIntangibleAssetsDetails</Role>
      <ShortName>Significant accounting policies - Intangible assets (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>58</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R59.htm</HtmlFileName>
      <LongName>2402405 - Disclosure - Significant accounting policies - Stock-based compensation (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SignificantAccountingPoliciesStockBasedCompensationDetails</Role>
      <ShortName>Significant accounting policies - Stock-based compensation (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>59</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R60.htm</HtmlFileName>
      <LongName>2403402 - Disclosure - Accounting pronouncements recently adopted - Schedule of Effects of Adopting New Revenue Standard (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AccountingPronouncementsRecentlyAdoptedScheduleOfEffectsOfAdoptingNewRevenueStandardDetails</Role>
      <ShortName>Accounting pronouncements recently adopted - Schedule of Effects of Adopting New Revenue Standard (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>60</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R61.htm</HtmlFileName>
      <LongName>2405402 - Disclosure - Acquisitions - Investments in affiliates and joint ventures (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AcquisitionsInvestmentsInAffiliatesAndJointVenturesDetails</Role>
      <ShortName>Acquisitions - Investments in affiliates and joint ventures (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>61</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R62.htm</HtmlFileName>
      <LongName>2405403 - Disclosure - Acquisitions - Heavy construction fleet and related assets (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AcquisitionsHeavyConstructionFleetAndRelatedAssetsDetails</Role>
      <ShortName>Acquisitions - Heavy construction fleet and related assets (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>62</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R63.htm</HtmlFileName>
      <LongName>2408402 - Disclosure - Accounts receivable (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AccountsReceivableDetails</Role>
      <ShortName>Accounts receivable (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/AccountsReceivableTables</ParentRole>
      <Position>63</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R64.htm</HtmlFileName>
      <LongName>2411402 - Disclosure - Prepaid expenses and deposits (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/PrepaidExpensesAndDepositsDetails</Role>
      <ShortName>Prepaid expenses and deposits (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/PrepaidExpensesAndDepositsTables</ParentRole>
      <Position>64</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R65.htm</HtmlFileName>
      <LongName>2412401 - Disclosure - Assets held for sale (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AssetsHeldForSaleDetails</Role>
      <ShortName>Assets held for sale (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/AssetsHeldForSale</ParentRole>
      <Position>65</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R66.htm</HtmlFileName>
      <LongName>2413402 - Disclosure - Property. plant and equipment (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/PropertyPlantAndEquipmentDetails</Role>
      <ShortName>Property. plant and equipment (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>66</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R67.htm</HtmlFileName>
      <LongName>2415402 - Disclosure - Other assets - Schedule of other assets (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherAssetsScheduleOfOtherAssetsDetails</Role>
      <ShortName>Other assets - Schedule of other assets (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>67</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R68.htm</HtmlFileName>
      <LongName>2415403 - Disclosure - Other assets - Intangible assets (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherAssetsIntangibleAssetsDetails</Role>
      <ShortName>Other assets - Intangible assets (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>68</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R69.htm</HtmlFileName>
      <LongName>2415404 - Disclosure - Other assets - Deferred financing costs (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherAssetsDeferredFinancingCostsDetails</Role>
      <ShortName>Other assets - Deferred financing costs (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>69</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R70.htm</HtmlFileName>
      <LongName>2415405 - Disclosure - Other assets - Deferred lease inducements asset (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherAssetsDeferredLeaseInducementsAssetDetails</Role>
      <ShortName>Other assets - Deferred lease inducements asset (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>70</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R71.htm</HtmlFileName>
      <LongName>2416402 - Disclosure - Income taxes - Expense (benefit) (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/IncomeTaxesExpenseBenefitDetails</Role>
      <ShortName>Income taxes - Expense (benefit) (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>71</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R72.htm</HtmlFileName>
      <LongName>2416403 - Disclosure - Income taxes - Deferred tax assets and liabilities (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/IncomeTaxesDeferredTaxAssetsAndLiabilitiesDetails</Role>
      <ShortName>Income taxes - Deferred tax assets and liabilities (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>72</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R73.htm</HtmlFileName>
      <LongName>2416404 - Disclosure - Income taxes - Narrative (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/IncomeTaxesNarrativeDetails</Role>
      <ShortName>Income taxes - Narrative (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>73</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R74.htm</HtmlFileName>
      <LongName>2416405 - Disclosure - Income taxes - Expiration of non-capital losses for income tax purposes (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/IncomeTaxesExpirationOfNonCapitalLossesForIncomeTaxPurposesDetails</Role>
      <ShortName>Income taxes - Expiration of non-capital losses for income tax purposes (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>74</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R75.htm</HtmlFileName>
      <LongName>2417402 - Disclosure - Accrued liabilities (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/AccruedLiabilitiesDetails</Role>
      <ShortName>Accrued liabilities (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/AccruedLiabilitiesTables</ParentRole>
      <Position>75</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R76.htm</HtmlFileName>
      <LongName>2418402 - Disclosure - Investments in affiliates and joint ventures - Ownership Percentages (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InvestmentsInAffiliatesAndJointVenturesOwnershipPercentagesDetails</Role>
      <ShortName>Investments in affiliates and joint ventures - Ownership Percentages (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>76</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R77.htm</HtmlFileName>
      <LongName>2418403 - Disclosure - Investments in affiliates and joint ventures - Summary of Movement in Investments In Affiliates and Joint Ventures (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InvestmentsInAffiliatesAndJointVenturesSummaryOfMovementInInvestmentsInAffiliatesAndJointVenturesDetails</Role>
      <ShortName>Investments in affiliates and joint ventures - Summary of Movement in Investments In Affiliates and Joint Ventures (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>77</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R78.htm</HtmlFileName>
      <LongName>2418404 - Disclosure - Investments in affiliates and joint ventures - Balance Sheets (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InvestmentsInAffiliatesAndJointVenturesBalanceSheetsDetails</Role>
      <ShortName>Investments in affiliates and joint ventures - Balance Sheets (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>78</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R79.htm</HtmlFileName>
      <LongName>2418405 - Disclosure - Investments in affiliates and joint ventures - Statements of Operations and Comprehensive Income (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InvestmentsInAffiliatesAndJointVenturesStatementsOfOperationsAndComprehensiveIncomeDetails</Role>
      <ShortName>Investments in affiliates and joint ventures - Statements of Operations and Comprehensive Income (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>79</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R80.htm</HtmlFileName>
      <LongName>2418406 - Disclosure - Investments in affiliates and joint ventures - Narrative (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InvestmentsInAffiliatesAndJointVenturesNarrativeDetails</Role>
      <ShortName>Investments in affiliates and joint ventures - Narrative (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>80</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R81.htm</HtmlFileName>
      <LongName>2419402 - Disclosure - Long term debt - Schedule of Long Term Debt (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebtScheduleOfLongTermDebtDetails</Role>
      <ShortName>Long term debt - Schedule of Long Term Debt (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>81</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R82.htm</HtmlFileName>
      <LongName>2419403 - Disclosure - Long term debt - Schedule of Credit Facilities (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebtScheduleOfCreditFacilitiesDetails</Role>
      <ShortName>Long term debt - Schedule of Credit Facilities (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>82</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R83.htm</HtmlFileName>
      <LongName>2419404 - Disclosure - Long term debt - Credit Facility Narrative (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebtCreditFacilityNarrativeDetails</Role>
      <ShortName>Long term debt - Credit Facility Narrative (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>83</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R84.htm</HtmlFileName>
      <LongName>2419405 - Disclosure - Long term debt - Convertible Debenture (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebtConvertibleDebentureDetails</Role>
      <ShortName>Long term debt - Convertible Debenture (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>84</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R85.htm</HtmlFileName>
      <LongName>2419406 - Disclosure - Long term debt - Mortgage (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebtMortgageDetails</Role>
      <ShortName>Long term debt - Mortgage (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>85</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R86.htm</HtmlFileName>
      <LongName>2419407 - Disclosure - Long term debt - Schedule of Promissory Notes (Details)</LongName>
      <ReportType>Notes</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebtScheduleOfPromissoryNotesDetails</Role>
      <ShortName>Long term debt - Schedule of Promissory Notes (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>86</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R87.htm</HtmlFileName>
      <LongName>2419408 - Disclosure - Long term debt - Promissory Notes (Details)</LongName>
      <ReportType>Notes</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebtPromissoryNotesDetails</Role>
      <ShortName>Long term debt - Promissory Notes (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>87</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R88.htm</HtmlFileName>
      <LongName>2419409 - Disclosure - Long term debt - Deferred Financing (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/LongTermDebtDeferredFinancingDetails</Role>
      <ShortName>Long term debt - Deferred Financing (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>88</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R89.htm</HtmlFileName>
      <LongName>2420402 - Disclosure - Capital lease obligations (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/CapitalLeaseObligationsDetails</Role>
      <ShortName>Capital lease obligations (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/CapitalLeaseObligationsTables</ParentRole>
      <Position>89</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R90.htm</HtmlFileName>
      <LongName>2421402 - Disclosure - Financial instruments and risk management - Financial instruments (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/FinancialInstrumentsAndRiskManagementFinancialInstrumentsDetails</Role>
      <ShortName>Financial instruments and risk management - Financial instruments (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>90</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R91.htm</HtmlFileName>
      <LongName>2421403 - Disclosure - Financial instruments and risk management - Assets held-for-sale (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/FinancialInstrumentsAndRiskManagementAssetsHeldForSaleDetails</Role>
      <ShortName>Financial instruments and risk management - Assets held-for-sale (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>91</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R92.htm</HtmlFileName>
      <LongName>2421404 - Disclosure - Financial instruments and risk management - Risk management (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/FinancialInstrumentsAndRiskManagementRiskManagementDetails</Role>
      <ShortName>Financial instruments and risk management - Risk management (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>92</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R93.htm</HtmlFileName>
      <LongName>2421405 - Disclosure - Financial instruments and risk management - Maximum credit exposure (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/FinancialInstrumentsAndRiskManagementMaximumCreditExposureDetails</Role>
      <ShortName>Financial instruments and risk management - Maximum credit exposure (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>93</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R94.htm</HtmlFileName>
      <LongName>2421406 - Disclosure - Financial instruments and risk management - Trade receivables (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/FinancialInstrumentsAndRiskManagementTradeReceivablesDetails</Role>
      <ShortName>Financial instruments and risk management - Trade receivables (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>94</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R95.htm</HtmlFileName>
      <LongName>2422402 - Disclosure - Other long term obligations - Schedule of other long term obligations (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherLongTermObligationsScheduleOfOtherLongTermObligationsDetails</Role>
      <ShortName>Other long term obligations - Schedule of other long term obligations (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>95</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R96.htm</HtmlFileName>
      <LongName>2422403 - Disclosure - Other long term obligations - Other liabilities and obligations (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherLongTermObligationsOtherLiabilitiesAndObligationsDetails</Role>
      <ShortName>Other long term obligations - Other liabilities and obligations (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>96</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R97.htm</HtmlFileName>
      <LongName>2424402 - Disclosure - Shares - Common shares (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SharesCommonSharesDetails</Role>
      <ShortName>Shares - Common shares (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>97</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R98.htm</HtmlFileName>
      <LongName>2424403 - Disclosure - Shares - Net income per share (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SharesNetIncomePerShareDetails</Role>
      <ShortName>Shares - Net income per share (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>98</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R99.htm</HtmlFileName>
      <LongName>2424404 - Disclosure - Shares - Share purchase program (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SharesSharePurchaseProgramDetails</Role>
      <ShortName>Shares - Share purchase program (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>99</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R100.htm</HtmlFileName>
      <LongName>2424405 - Disclosure - Shares - Dividends (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/SharesDividendsDetails</Role>
      <ShortName>Shares - Dividends (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>100</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R101.htm</HtmlFileName>
      <LongName>2426402 - Disclosure - Revenue - Disaggregation of revenue (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RevenueDisaggregationOfRevenueDetails</Role>
      <ShortName>Revenue - Disaggregation of revenue (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>101</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R102.htm</HtmlFileName>
      <LongName>2426403 - Disclosure - Revenue - Schedule of major customers (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RevenueScheduleOfMajorCustomersDetails</Role>
      <ShortName>Revenue - Schedule of major customers (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>102</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R103.htm</HtmlFileName>
      <LongName>2426404 - Disclosure - Revenue - Contract balances (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RevenueContractBalancesDetails</Role>
      <ShortName>Revenue - Contract balances (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>103</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R104.htm</HtmlFileName>
      <LongName>2426405 - Disclosure - Revenue - Unpriced contract modifications (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RevenueUnpricedContractModificationsDetails</Role>
      <ShortName>Revenue - Unpriced contract modifications (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>104</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R105.htm</HtmlFileName>
      <LongName>2426406 - Disclosure - Revenue - Estimated revenue expected to be recognized in the future related to performance obligations (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RevenueEstimatedRevenueExpectedToBeRecognizedInFutureRelatedToPerformanceObligationsDetails</Role>
      <ShortName>Revenue - Estimated revenue expected to be recognized in the future related to performance obligations (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>105</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R106.htm</HtmlFileName>
      <LongName>2426407 - Disclosure - Revenue - Contract costs (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RevenueContractCostsDetails</Role>
      <ShortName>Revenue - Contract costs (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>106</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R107.htm</HtmlFileName>
      <LongName>2427402 - Disclosure - Commitments (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/CommitmentsDetails</Role>
      <ShortName>Commitments (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/CommitmentsTables</ParentRole>
      <Position>107</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R108.htm</HtmlFileName>
      <LongName>2428402 - Disclosure - Interest expense (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/InterestExpenseDetails</Role>
      <ShortName>Interest expense (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/InterestExpenseTables</ParentRole>
      <Position>108</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R109.htm</HtmlFileName>
      <LongName>2430402 - Disclosure - Stock-based compensation - Stock-based compensation expenses (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/StockBasedCompensationStockBasedCompensationExpensesDetails</Role>
      <ShortName>Stock-based compensation - Stock-based compensation expenses (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>109</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R110.htm</HtmlFileName>
      <LongName>2430403 - Disclosure - Stock-based compensation - Share options plan (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/StockBasedCompensationShareOptionsPlanDetails</Role>
      <ShortName>Stock-based compensation - Share options plan (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>110</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R111.htm</HtmlFileName>
      <LongName>2430404 - Disclosure - Stock-based compensation - Options by exercise price range (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/StockBasedCompensationOptionsByExercisePriceRangeDetails</Role>
      <ShortName>Stock-based compensation - Options by exercise price range (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>111</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R112.htm</HtmlFileName>
      <LongName>2430405 - Disclosure - Stock-based compensation - Restricted share unit plan (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/StockBasedCompensationRestrictedShareUnitPlanDetails</Role>
      <ShortName>Stock-based compensation - Restricted share unit plan (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>112</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R113.htm</HtmlFileName>
      <LongName>2430406 - Disclosure - Stock-based compensation - Performance and deferred stock unit plan (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/StockBasedCompensationPerformanceAndDeferredStockUnitPlanDetails</Role>
      <ShortName>Stock-based compensation - Performance and deferred stock unit plan (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>113</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R114.htm</HtmlFileName>
      <LongName>2431402 - Disclosure - Other information Other information - Supplemental cash flow information (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherInformationOtherInformationSupplementalCashFlowInformationDetails</Role>
      <ShortName>Other information Other information - Supplemental cash flow information (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>114</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R115.htm</HtmlFileName>
      <LongName>2431403 - Disclosure - Other information - Non-cash (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/OtherInformationNonCashDetails</Role>
      <ShortName>Other information - Non-cash (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <Position>115</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R116.htm</HtmlFileName>
      <LongName>2434401 - Disclosure - Employee benefit plans (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/EmployeeBenefitPlansDetails</Role>
      <ShortName>Employee benefit plans (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/EmployeeBenefitPlans</ParentRole>
      <Position>116</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R117.htm</HtmlFileName>
      <LongName>2435402 - Disclosure - Related party transactions (Details)</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://www.nacg.ca/role/RelatedPartyTransactionsDetails</Role>
      <ShortName>Related party transactions (Details)</ShortName>
      <MenuCategory>Details</MenuCategory>
      <ParentRole>http://www.nacg.ca/role/RelatedPartyTransactionsTables</ParentRole>
      <Position>117</Position>
    </Report>
    <Report instance="noa-20181231.xml">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R9999.htm</HtmlFileName>
      <LongName>Uncategorized Items - noa-20181231.xml</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://xbrl.sec.gov/role/uncategorizedFacts</Role>
      <ShortName>Uncategorized Items - noa-20181231.xml</ShortName>
      <MenuCategory>Cover</MenuCategory>
      <Position>118</Position>
    </Report>
    <Report>
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <LongName>All Reports</LongName>
      <ReportType>Book</ReportType>
      <ShortName>All Reports</ShortName>
    </Report>
  </MyReports>
  <InputFiles>
    <File>noa-20181231.xml</File>
    <File>noa-20181231.xsd</File>
    <File>noa-20181231_cal.xml</File>
    <File>noa-20181231_def.xml</File>
    <File>noa-20181231_lab.xml</File>
    <File>noa-20181231_pre.xml</File>
  </InputFiles>
  <SupplementalFiles/>
  <BaseTaxonomies>
    <BaseTaxonomy>http://xbrl.sec.gov/dei/2018-01-31</BaseTaxonomy>
    <BaseTaxonomy>http://fasb.org/srt/2018-01-31</BaseTaxonomy>
    <BaseTaxonomy>http://fasb.org/us-gaap/2018-01-31</BaseTaxonomy>
  </BaseTaxonomies>
  <HasPresentationLinkbase>true</HasPresentationLinkbase>
  <HasCalculationLinkbase>true</HasCalculationLinkbase>
</FilingSummary>
